#
from enigma import *
from Screens.Screen import Screen
from Screens.MessageBox import MessageBox
from Screens.InputBox import InputBox
from Screens.ChoiceBox import ChoiceBox
from Components.ActionMap import ActionMap, NumberActionMap
from Components.ScrollLabel import ScrollLabel
from Components.GUIComponent import *
from Components.MenuList import MenuList
from Components.Input import Input
from Screens.Console import Console
from Plugins.Plugin import PluginDescriptor
from Screens.ImageWizard import ImageWizard
from Plugins.Plugin import PluginDescriptor

import os

###############################################################################

cronmanager_path = "/etc/cron"
cronmanager_script = "/etc/cron/cronmanager.sh"
cronmanager_installscript = "/var/tmp/cronmanager.sh"
cronmanager_readme = "/etc/cron/readme.txt"

###############################################################################
# versionstring
###############################################################################
cronmanager_pluginversion = "V1.5"

###############################################################################
def main(session,**kwargs):
    try:    
     	session.open(Cronmanager)
    except:
        print "[CRONMANAGER] Pluginexecution failed"
###############################################################################
def autostart(reason,**kwargs):
    if reason == 0:
        print "[CRONMANAGER] no autostart"
###############################################################################
def Plugins(**kwargs):
    return PluginDescriptor(
        name="Cronmanager", 
        description="plugin to do cron daemon management", 
        where = PluginDescriptor.WHERE_PLUGINMENU,
        fnc = main
        )
###############################################################################
###############################################################################
class Cronmanager(Screen):
    skin = """
        <screen position="100,100" size="500,400" title="Cronmanager Menu" >
            <widget name="menu" position="10,10" size="490,390" scrollbarMode="showOnDemand" />
        </screen>"""
        
    def __init__(self, session, args = 0):
        self.skin = Cronmanager.skin
        self.session = session
        Screen.__init__(self, session)
        self.menu = args
        list = []
        list.append((_("list crontab"), "list"))        
        list.append((_("add command to crontab with time"), "addwizzard"))
        list.append((_("add command to crontab with delay"), "laterwizzard"))
        list.append((_("delete crontab"), "delete"))        
        list.append((_("reload crontab"), "reload"))        
        list.append((_("info if cron dameon is running"), "info"))        
        list.append((_("show system time cron dameon is using"), "time"))        
        list.append((_("restart options"), "restartwizzard"))
        list.append((_("install options (enable once before using !)"), "installwizzard"))
        list.append((_("help"), "help"))        
#        list.append((_("man"), "man"))        
        list.append((_("about"), "about"))        
        self["menu"] = MenuList(list)
        self["actions"] = ActionMap(["WizardActions", "DirectionActions"],{"ok": self.go,"back": self.close,}, -1)
        
    def go(self):
        returnValue = self["menu"].l.getCurrentSelection()[1]
        if returnValue is not None:
           if returnValue is "addwizzard":
               AddCommandWizzard(self.session)
           elif returnValue is "laterwizzard":
               LaterCommandWizzard(self.session)
           elif returnValue is "list":
             self.session.open(Console,_("Listing crontab"),["%s list" % cronmanager_script])
           elif returnValue is "delete":
             self.session.open(Console,_("Deleting crontab"),["%s delete" % cronmanager_script])
           elif returnValue is "reload":
             self.session.open(Console,_("Reloading crontab"),["%s reload" % cronmanager_script])
           # Info
           elif returnValue is "info":
             self.session.open(Console,_("showing Cronmanager Info"),["%s info" % cronmanager_script])
           elif returnValue is "time":
             self.session.open(Console,_("showing system time "),["%s time" % cronmanager_script])
#           elif returnValue is "log":
#             self.session.open(Console,_("showing log"),["%s log" % (cronmanager_script)])
           elif returnValue is "restartwizzard":
               RestartWizzard(self.session)
           elif returnValue is "installwizzard":
               InstallWizzard(self.session)
#           elif returnValue is "man":
#             self.session.open(Console,_("man shows readme.txt of Cronmanager"),["cat %s" % cronmanager_readme])
           elif returnValue is "help":
             self.session.open(Console,_("short help on Cronmanager commands"),["%s" % cronmanager_script])
           elif returnValue is "about":
             self.session.open(MessageBox,_("Cronmanager Enigma2 Plugin %s\n\nCronmanager tool by thowi\n\nEnjoy managing cron daemon with your remote control !" % cronmanager_pluginversion), MessageBox.TYPE_INFO)

###############################################################################
###############################################################################


class AddCommandWizzard(Screen):
    def __init__(self, session):

        self.session = session
        self.askForCommand()

    def askForCommand(self):
	       self.session.openWithCallback(self.processingCommand,InputBox, title=_("Enter a script to execute at time"), text="/etc/cron/examples/rmc.sh 30 8" , maxSize=False, type=Input.TEXT)

    def processingCommand(self,targetname):
        if targetname is None:
            self.skipCommand("Script for adding to crontab is NONE, skipping crontab add command")
        else:
            self.targetname = targetname
            self.session.openWithCallback(self.DoCommand,MessageBox,_("are you sure to add this script to crontab: %s ?" % (self.targetname)), MessageBox.TYPE_YESNO)

    def DoCommand(self,answer):
        if answer is None:
            self.skipCommand("answer is None")
        if answer is False:
            self.skipCommand("you were not confirming")
        else:
            title = "adding script %s to crontab with time" %(self.targetname)
            cmd = "%s add %s" % (cronmanager_script,self.targetname)
            self.session.open(Console,_(title),[cmd])
            
    def skipCommand(self,reason):
        self.session.open(MessageBox,_("add script to crontab was canceled, because %s" % reason), MessageBox.TYPE_WARNING)
        
        
###############################################################################
###############################################################################

class LaterCommandWizzard(Screen):
    def __init__(self, session):

        self.session = session
        self.askForLaterCommand()

    def askForLaterCommand(self):
	       self.session.openWithCallback(self.processingLaterCommand,InputBox, title=_("Enter a script to execute with delay"), text="/etc/cron/examples/slt.sh 60" , maxSize=False, type=Input.TEXT)

    def processingLaterCommand(self,targetname):
        if targetname is None:
            self.skipLaterCommand("Script for adding to crontab is NONE, skipping crontab delay command")
        else:
            self.targetname = targetname
            self.session.openWithCallback(self.DoLaterCommand,MessageBox,_("are you sure to add this script to crontab: %s ?" % (self.targetname)), MessageBox.TYPE_YESNO)

    def DoLaterCommand(self,answer):
        if answer is None:
            self.skipLaterCommand("answer is None")
        if answer is False:
            self.skipLaterCommand("you were not confirming")
        else:
            title = "adding script %s to crontab with delay" %(self.targetname)
            cmd = "%s delay %s" % (cronmanager_script,self.targetname)
            self.session.open(Console,_(title),[cmd])
            
    def skipLaterCommand(self,reason):
        self.session.open(MessageBox,_("delay script to crontab was canceled, because %s" % reason), MessageBox.TYPE_WARNING)
        
        
###############################################################################
###############################################################################

class InstallWizzard(Screen):
    def __init__(self, session):
        self.session = session
        self.askForInstall()
        
    def askForInstall(self):
            self.session.openWithCallback(self.askForCommand,ChoiceBox,_("select Cronmanager install command to be executed"),self.getCommandList())

    def askForCommand(self,source):
        if source is None:
            self.skipInstall("no command passed, skipping install")
        else:
            self.source = source [1]
            self.session.openWithCallback(self.installCommand,MessageBox,_("are you sure to install Cronmanager with %s" % self.source), MessageBox.TYPE_YESNO)
            
    def installCommand(self,answer):
        if answer is None:
            self.skipInstall("answer is None")
        if answer is False:
            self.skipInstall("you were not confirming")
        else:
            if os.path.exists(cronmanager_installscript) == False:
             	self.session.open(Console,_("executing install command at /etc/cron"),["%s %s" % (cronmanager_script,self.source)])
            else:
             	self.session.open(Console,_("executing install command at /var/tmp"),["%s %s" % (cronmanager_installscript,self.source)])
            
    def skipInstall(self,reason):
        self.session.open(MessageBox,_("install was canceled, because %s" % reason), MessageBox.TYPE_WARNING)
        
    def getCommandList(self):
        images = []
        images.append((_("enable  Cronmanager and cron daemon"),"enable"))
        images.append((_("disable Cronmanager and cron daemon"),"disable"))
        return images
        
###############################################################################
###############################################################################

class RestartWizzard(Screen):
    def __init__(self, session):
        self.session = session
        self.askForRestart()
        
    def askForRestart(self):
            self.session.openWithCallback(self.askForCommand,ChoiceBox,_("select restart command to be executed"),self.getCommandList())

    def askForCommand(self,source):
        if source is None:
            self.skipRestart("no command passed, skipping restart")
        else:
            self.source = source [1]
            self.session.openWithCallback(self.restartCommand,MessageBox,_("are you sure to %s" % self.source), MessageBox.TYPE_YESNO)
            
    def restartCommand(self,answer):
        if answer is None:
            self.skipRestart("answer is None")
        if answer is False:
            self.skipRestart("you were not confirming")
        else:
            title = "executing command on Dreambox"
            cmd = "%s %s"  % (cronmanager_script,self.source)
            self.session.open(Console,_(title),[cmd])
            
    def skipRestart(self,reason):
        self.session.open(MessageBox,_("restart was canceled, because %s" % reason), MessageBox.TYPE_WARNING)
        
    def getCommandList(self):
        images = []
        images.append((_("info if cron dameon is running"),"info"))
        images.append((_("start   cron daemon"),"start"))
        images.append((_("stop    cron daemon"),"stop"))
        images.append((_("restart cron dameon"),"restart"))
        images.append((_("reboot  Dreambox"),"reboot"))
        images.append((_("halt    Dreambox"),"halt"))
        images.append((_("restart Enigma on Dreambox"),"kill"))
        return images

###############################################################################
###############################################################################

