#!/bin/sh
#
VERSION=$1
#
INSTALLDIR=/var/tmp
PLUGINDIR=/usr/lib/enigma2/python/Plugins/Extensions
if [ -f /bin/enigma ]; then
CMHOME=/var/etc/cron
else
CMHOME=/etc/cron
fi

if [ -z $VERSION ]; then
echo "Version needs to be passed as argument, cann't do anything"
echo "---------------------------------------------"
exit 1
fi
 
echo "---------------------------------------------"
echo "Creating Cronmanager Installation Kit"
echo "---------------------------------------------"

if [ ! -d $INSTDIR ]; then
mkdir $INSTALLDIR
fi
cp $CMHOME/cronmanager.sh $INSTALLDIR
if [ ! -f /bin/enigma ]; then
if [ -d $PLUGINDIR/Cronmanager ]; then
rm -r $PLUGINDIR/Cronmanager 
else
rm $PLUGINDIR/Cronmanager 
fi
cp -r $CMHOME/Cronmanager $PLUGINDIR/Cronmanager
dos2unix $CMHOME/readme.txt
fi
if [ -f /bin/enigma ]; then
echo "Making enigma kit"
tar -cf $INSTALLDIR/cronmanager$VERSION.tar /var/bin/crond /var/etc/init /var/etc/cron/init /var/etc/crontab $CMHOME/cronmanager.sh $CMHOME/examples/*.sh $CMHOME/makekit.sh $CMHOME/readme.txt $INSTALLDIR/cronmanager.sh
else
if [ ! $2 ]; then
echo "Making full kit"
tar -cf $INSTALLDIR/cronmanager$VERSION.tar /etc/init.d/busybox-cron $PLUGINDIR/Cronmanager/*.py $CMHOME/Cronmanager/*.py $CMHOME/cronmanager.sh $CMHOME/examples/*.sh $CMHOME/bzip2* $CMHOME/makekit.sh $CMHOME/readme.txt $INSTALLDIR/cronmanager.sh
else
echo "Making lite kit"
tar -cf $INSTALLDIR/cronmanager$VERSION.tar /etc/init.d/busybox-cron $PLUGINDIR/Cronmanager/*.py $CMHOME/Cronmanager/*.py $CMHOME/cronmanager.sh $CMHOME/examples/*.sh $CMHOME/makekit.sh $CMHOME/readme.txt $INSTALLDIR/cronmanager.sh
fi
fi
echo " Kit contains "
echo "---------------------------------------------"
tar -tvf $INSTALLDIR/cronmanager$VERSION.tar
echo "---------------------------------------------"
if [ ! -f /bin/enigma ]; then
if [ ! -f /usr/bin/bzip2 ]; then
ipkg install $CMHOME/bzip2*
echo "---------------------------------------------"
fi
fi
echo "Copying kit to $INSTALLDIR"
echo "---------------------------------------------"
if [ ! -f /bin/enigma ]; then
bzip2 -f $INSTALLDIR/cronmanager$VERSION.tar
fi
cp $CMHOME/cronmanager.sh $INSTALLDIR
ls -1alh $INSTALLDIR/cronmanager$VERSION.tar*
ls -1alh $INSTALLDIR/cronmanager.sh
echo "---------------------------------------------"
if [ ! -f /bin/enigma ]; then
rm -r $PLUGINDIR/Cronmanager 
ln -sfn $CMHOME/Cronmanager $PLUGINDIR/Cronmanager
fi
cd $CMHOME
exit 0


