#!/bin/sh
#
# cronmanager.sh from thowi
#
VERSION=15
CMKIT=cronmanager$VERSION.tar
#
INSTALLDIR=/var/tmp
#
# device specific variables
#
if [ -e /bin/enigma ]; then
#echo "Running on enigma"
CMHOME=/var/etc/cron
CMHOMETABS=/var/etc/crontab
else
#echo "Running on enigma2"
CMHOME=/etc/cron
CMHOMETABS=/etc/cron/crontabs
fi
# device paths
#
LOG=$INSTALLDIR/cronmanager.log
#echo "---------- Starting $LOG ---------" > $LOG
HELP=$CMHOME/readme.txt
PLUGINDIR=/usr/lib/enigma2/python/Plugins/Extensions
VOLATILES=/etc/default/volatiles/00_core
MAKEKIT=$CMHOME/makekit.sh
CMSTART=S21cron
CMSTOP=K21cron
CRONDAEMONSCRIPT=/etc/init.d/busybox-cron
CRONTAB=/usr/bin/crontab
CRONTABFILE=$CMHOME/crontabfile
#
THINK=5
BZIP2=/usr/bin/bzip2
DEBUG=$CMHOME/.cmdebug
CMCONFIG=".cmconfig"
CMTYPE=""


if [ -f $DEBUG ]; then
             echo "----------------------------------------------------"
#             echo $0 $1 $2 $3 $4 $5 $6
             wall "$0 $1 $2 $3 $4 $5 $6"
             echo "----------------------------------------------------"
#             exit 0
fi

if  [ ! -d $INSTALLDIR ]; then
        mkdir $INSTALLDIR
fi

if  [ -f $CMHOME/$CMCONFIG ]; then
    CMTYPE=`cat $CMHOME/$CMCONFIG`
fi
# echo "Instalation type $CMTYPE"
# exit 0


cd /

case "$1" in
   "man")
      if [ $THINK ! = 0 ]; then
      echo "-----------------------------------------------------"
      echo "For scrolling trough help press space bar"
      echo "for finishing reading presse CTRL + C"
      echo "readme.txt will be shown in $THINK seconds"
      echo "-----------------------------------------------------"
      sleep $THINK
      fi
      echo "Showing $HELP"
      more $HELP
      exit 0
   ;;
   "log")
      echo "-----------------------------------------------------"
      echo "Display Logfile from last execution of" $0
#      echo "-----------------------------------------------------"
      if  [ ! -f $LOG ]; then
        echo "No log file available - sorry"
        exit 1
      else
        ls -al $LOG
        echo "-----------------------------------------------------"
        cat $LOG
        echo "-----------------------------------------------------"
      fi
      exit 0
      ;;
   "reboot")
      echo "------------------------------------------"
      echo "Rebooting in $THINK seconds"  
      echo "------------------------------------------"
      sleep $THINK
      echo "Rebooting NOW"
      echo "------------------------------------------"
      if [ -f /sbin/reboot ]; then 
      reboot
      else   
      shutdown -r now
      fi
      exit 0
   ;;
   "halt")
      echo "------------------------------------------"
      echo "Shutdown in $THINK seconds"  
      echo "------------------------------------------"
      sleep $THINK
      echo "Shutting down NOW"
      echo "------------------------------------------"
      if [ -f /sbin/halt ]; then 
      halt
      else
      shutdown -h now
      fi
      exit 0
   ;;
   "kill")
      echo "------------------------------------------"
      echo "enigma will be restarted in $THINK seconds"
      echo "------------------------------------------"
      sleep $THINK
      if [ -f /bin/enigma ]; then
      echo "enigma will be restarted NOW"
      killall enigma
      else 
      echo "enigma2 will be restarted NOW"
      killall enigma2
      fi
      exit 0
   ;;
   "time")
      echo "------------------------------------------"
      echo "showing system time and date cron daemon is using"
      echo "------------------------------------------"
      date -u
      echo "------------------------------------------"
   ;;
   "start")
echo "-----------------------------------------------------"
   echo "Starting cron dameon ..."
   if [ -f /bin/enigma ]; then
      /var/bin/crond > /dev/null 2<&1 &
   else
      $CRONDAEMONSCRIPT start
   fi
echo "-----------------------------------------------------"
   exit 0
   ;;
   "stop")
echo "-----------------------------------------------------"
   echo "Stopping cron dameon ..."
   if [ -f /bin/enigma ]; then
      killall crond
   else
      $CRONDAEMONSCRIPT stop
   fi
echo "-----------------------------------------------------"
   exit 0
   ;;
   "restart")
echo "-----------------------------------------------------"
   echo "Restarting cron dameon ..."
   if [ -f /bin/enigma ]; then
      killall crond
      /var/bin/crond > /dev/null 2<&1 &
   else
      $CRONDAEMONSCRIPT restart
   fi
echo "-----------------------------------------------------"
   exit 0
   ;;
   "reload")
echo "-----------------------------------------------------"
   echo "Reloading crontab ..."
   $CRONDAEMONSCRIPT reload
echo "-----------------------------------------------------"
   exit 0
   ;;
   "list")
echo "-----------------------------------------------------"
   echo "Listing crontab ..."
echo "-----------------------------------------------------"
   if [ -f /bin/enigma ]; then
   if [ -f /var/etc/crontab ]; then
      cat /var/etc/crontab
   fi
   else
      $CRONTAB -l
   fi
echo "-----------------------------------------------------"
   exit 0
   ;;
   "delete")
echo "-----------------------------------------------------"
   echo "Deleting crontab ..."
   if [ -f /bin/enigma ]; then
      rm /var/etc/crontab
   else 
      $CRONTAB -d
   fi
echo "-----------------------------------------------------"
   exit 0
   ;;
   "plugin")
   if [ -f /bin/enigma ]; then
   echo "menu interface not (yet) available for enimga1"
   exit 0
   fi
         echo "-----------------------------------------------------"
         if  [ -d $PLUGINDIR/Cronmanager ]; then
           echo "Changing Cronmanager Plugin to be link to $CMHOME/Cronmanager"
           rm -r $PLUGINDIR/Cronmanager >> $LOG 2>&1
         fi
         echo "Creating link for cronmanager addon"
         ln -sfn $CMHOME/Cronmanager $PLUGINDIR/Cronmanager 
         echo "-----------------------------------------------------"
         echo "Restarting enigma in $THINK seconds"
         sleep $THINK
         killall enigma2
   ;;
   "info")
echo "---------- Starting $LOG ---------" > $LOG
echo "-----------------------------------------------------"
echo "Check next line if cron dameon is running"
echo "-----------------------------------------------------"
   if [ -f /bin/enigma ]; then
ps ax | grep /var/bin/crond 
else
ps ax | grep /usr/sbin/crond | grep crontab
fi
echo "-----------------------------------------------------"
;;
   "enable")
   if [ -f /bin/enigma ]; then
   echo "crond ist automatically enabled for enigma1 - maybe reboot"
   cp /var/etc/cron/init /var/etc/init
   exit 0
   fi
echo "---------- Starting $LOG ---------" > $LOG
      echo "-----------------------------------------------------"
      echo "Enabling / Updating Cronmanager ..."
      if  [ $0 != $INSTALLDIR/cronmanager.sh ]; then
           echo "cronmanager.sh should be called for $1 from /"
           echo "with $INSTALLDIR/cronmanager.sh $1"
           echo "just checking if there is a kit to be extracted"
      echo "-----------------------------------------------------"
      if  [ ! -f $INSTALLDIR/cronmanager*.tar.bz2 ]; then
         if  [ ! -f $INSTALLDIR/cronmanager*.tar ]; then
             echo "nothing found at $INSTALLDIR"
             echo "Rebuilding Kit from files at $CMHOME ..."
             $MAKEKIT $VERSION 
         else
             echo "using kit $INSTALLDIR/cronmanagerXX.tar"
         fi
      fi
      cd /
      bunzip2 $INSTALLDIR/cronmanager*.tar.bz2 >> /dev/null 2>&1
      tar -xf $INSTALLDIR/cronmanager*.tar >> /dev/null 2>&1
      echo "-----------------------------------------------------"
           echo "Try now executing again from / with $INSTALLDIR/cronmanager.sh $1"
      echo "-----------------------------------------------------"
           exit 0
      fi
#
# kit now already unpacked at /var/tmp
#
# Starting Installation NOW
#
         
         cd $CMHOME
         mkdir $CMHOME/crontabs
         if  [ -d $CMHOME/var ]; then
         rm -r $CMHOME/var >> $LOG 2>&1
         fi
         if  [ -d $CMHOME/usr ]; then
         rm -r $CMHOME/usr >> $LOG 2>&1
         fi
         if  [ -d $PLUGINDIR/Cronmanager ]; then
           echo "Changing Cronmanager Plugin to be link to $CMHOME/Cronmanager"
           rm -r $PLUGINDIR/Cronmanager >> $LOG 2>&1
         fi
         echo "Creating link for cronmanager addon"
         ln -sfn $CMHOME/Cronmanager $PLUGINDIR/Cronmanager 
         cd $CMHOME 
         echo "d root root 0755 /var/spool/cron" >> $VOLATILES
         echo "l root root 0755 /var/spool/cron/crontabs /etc/cron/crontabs" >> $VOLATILES
         ln -sfn $CRONDAEMONSCRIPT /etc/rc3.d/$CMSTART
         echo "Enabling Cronmanager and cron dameon finished !"
         echo "-----------------------------------------------------"
         echo "Will reboot in 10 secs, after this cron dameon should"
         echo "be running - check with cronmanager info"
         echo "-----------------------------------------------------"
         sleep 10
         shutdown -r now
         exit 0
;; 
   "disable")
   if [ -f /bin/enigma ]; then
   echo "disabling crond on enigma1, maybe reboot"
   killall  crond
   rm /var/etc/init
   exit 0
   fi
echo "---------- Starting $LOG ---------" > $LOG
      echo "-----------------------------------------------------"
         echo "Disabling Cronmanager ..."
      if  [ $0 != $INSTALLDIR/cronmanager.sh ]; then
           echo "cronmanager.sh should be called for $1 from /"
           echo "with $INSTALLDIR/cronmanager.sh $1"
           echo "just checking if there is a kit to be extracted"
      echo "-----------------------------------------------------"
      if  [ ! -f $INSTALLDIR/cronmanager*.tar.bz2 ]; then
         if  [ ! -f $INSTALLDIR/cronmanager*.tar ]; then
             echo "nothing found at $INSTALLDIR"
             echo "Rebuilding Kit from files at $CMHOME ..."
             $MAKEKIT $VERSION 
#             cp $CMHOME/cronmanager*.tar.bz2 $INSTALLDIR
             bunzip2 $INSTALLDIR/cronmanager*.tar.bz2
         else
             echo "using kit $INSTALLDIR/cronmanagerXX.tar"
         fi
      fi
      cd /
      bunzip2 $INSTALLDIR/cronmanager*.tar.bz2 >> /dev/null 2>&1
      tar -xf $INSTALLDIR/cronmanager*.tar >> /dev/null 2>&1
      cp $CMHOME/cronmanager.sh $INSTALLDIR
      echo "-----------------------------------------------------"
           echo "Try now executing again from / with $INSTALLDIR/cronmanager.sh $1"
      echo "-----------------------------------------------------"
           exit 0
      fi
# kit now already unpacked at /var/tmp
# either manually, automatic from above or from Blue Pannel 
         echo "-----------------------------------------------------"
   cd /
   if [ -f /etc/rc3.d/$CMSTART ] ; then
      rm /etc/rc3.d/$CMSTART
   fi
   if  [ -d $PLUGINDIR/Cronmanager ]; then
   rm -r $PLUGINDIR/Cronmanager
   fi
   if  [ -d $CMHOME ]; then
        rm -r $CMHOME
   fi
   sed -ie '$ d' $VOLATILES
   sed -ie '$ d' $VOLATILES

         echo "Deinstallation of cronmanager finished !"
         echo "-----------------------------------------------------"
         echo "Will reboot in 10 secs, after this cron dameon should"
         echo "be disabled and cronmanager deinstalled"
         echo "-----------------------------------------------------"
         sleep 10
         shutdown -r now
         exit 0
;;
"delay")
if  [  ! $2 ]; then
     echo "No command passed, cann't do anything - exiting !"
     exit 1
else
    CRONCOMMAND=$2
    if [  ! -f $CRONCOMMAND ]; then
       echo "Command $CRONCOMMAND doesn't exist - exiting !"
       exit 1
    fi
fi
if  [  ! $3 ]; then
    echo "No time passed, assuming 60 min"
    LATER=60
else
    LATER=$3
fi
if  [ $LATER -gt 1440 ]; then
    echo "time is longer then 1 day, use normal crontab entry for this, sorry"
    exit 1
fi
if  [ $LATER -lt 1 ]; then
    echo "time is too small, assuming 1 minute"
    LATER=1
fi
# processing time
CDATE=`date -u`
CSEC=`date -u +'%s'`
CHOUR=`date -u +'%H'`
CMINUTE=`date -u +'%M'`
CMONTH=`date -u +'%m'`
CMONTHDAY=`date -u +'%d'`
CWEEKDAY=`date -u +'%w'`
#echo "Current time in seconds since 1970: $CSEC"
LSEC=`expr $LATER "*" 60`
#echo "Seconds in the Future $LSEC"
#LSEC=`expr $LSEC "+" $CSEC`
#echo "Later time in seconds since 1970: $LSEC"
#echo "Current time: $CDATE"
#echo "Current time in cron format: $CMINUTE $CHOUR $CMONTHDAY $CMONTH $CWEEKDAY"
DATE=`date -d $CHOUR:$CMINUTE:$LSEC`
HOUR=`date -d $CHOUR:$CMINUTE:$LSEC +'%H'`
MINUTE=`date -d $CHOUR:$CMINUTE:$LSEC +'%M'`
MONTH=`date -d $CHOUR:$CMINUTE:$LSEC +'%m'`
MONTHDAY=`date -d $CHOUR:$CMINUTE:$LSEC +'%d'`
WEEKDAY=`date -d $CHOUR:$CMINUTE:$LSEC +'%w'`
#echo "Later   time: $DATE"
#echo "Later   time in cron format: $MINUTE $HOUR $MONTHDAY $MONTH $WEEKDAY"
echo "--------------------------------------------------"
echo "new crontab line will be like this:"
echo "--------------------------------------------------"
FULLCOMMAND="$MINUTE $HOUR $MONTHDAY $MONTH $WEEKDAY $CRONCOMMAND"
echo $FULLCOMMAND > $CRONTABFILE
sed -ie s!"%"!!g $CRONTABFILE
cat $CRONTABFILE
if [ -f /bin/enigma ]; then
if [ -f /var/etc/crontab ]; then
cat /var/etc/crontab > $CRONTABFILE
else
rm $CRONTABFILE
touch $CRONTABFILE
fi
else
$CRONTAB -l > $CRONTABFILE 
fi
echo $FULLCOMMAND >> $CRONTABFILE
sed -ie s!"%"!!g $CRONTABFILE
#echo "--------------------------------------------------"
#echo "appendign line to crontab now ..."
if [ -f /bin/enigma ]; then
cp $CRONTABFILE /var/etc/crontab
else
$CRONTAB $CRONTABFILE
fi
echo "--------------------------------------------------"
echo "Displaying new crontab:"
echo "--------------------------------------------------"
if [ -f /bin/enigma ]; then
if [ -f /var/etc/crontab ]; then
cat /var/etc/crontab 
fi
else
$CRONTAB -l
fi
echo "--------------------------------------------------"




exit 0
;;
"add")
if  [  ! $2 ]; then
     echo "No script passed, cann't do anything - exiting !"
     exit 1
else
    CRONCOMMAND=$2
    if [  ! -f $CRONCOMMAND ]; then
       echo "script $CRONCOMMAND doesn't exist - exiting !"
       exit 1
    fi
fi
#echo "script to be executed $CMHOME/$CRONCOMMAND"
if  [  ! $3 ]; then
    MINUTE="%*"
else
if  [  $3 -lt 0 ]; then
    MINUTE="%*"
else
if  [  $3 -gt 59 ]; then
    MINUTE="%*"
else
    MINUTE=$3
fi
fi
fi
#echo "Minute $MINUTE (0-59)"
if  [  ! $4 ]; then
    HOUR="%*"
else
if  [  $4 -lt 0 ]; then
    HOUR="%*"
else
if  [  $4 -gt 23 ]; then
    HOUR="%*"
else
    HOUR=$4
fi
fi
fi
#echo "Hour $HOUR (0-23)"
if  [  ! $5 ]; then
    MONTHDAY="%*"
else
if  [  $5 -lt 1 ]; then
    MONTHDAY="%*"
else
if  [  $5 -gt 31 ]; then
    MONTHDAY="%*"
else
    MONTHDAY=$5
fi
fi
fi
#echo "Day of month $MONTHDAY (1-31)"
if  [  ! $6 ]; then
    MONTH="%*"
else
if  [  $6 -lt 1 ]; then
    MONTH="%*"
else
if  [  $6 -gt 12 ]; then
    MONTH="%*"
else
    MONTH=$6
fi
fi
fi
#echo "Month $MONTH (1-12)"
if  [  ! $7 ]; then
    WEEKDAY="%*"
else
if  [  $7 -lt 0 ]; then
    WEEKDAY="%*"
else
if  [  $7 -gt 6 ]; then
    WEEKDAY="%*"
else
    WEEKDAY=$7
fi
fi
fi
#echo "Day of week $WEEKDAY (0-6 Sunday = 6)"
echo "--------------------------------------------------"
echo "new crontab line will be like this:"
echo "--------------------------------------------------"
FULLCOMMAND="$MINUTE $HOUR $MONTHDAY $MONTH $WEEKDAY $CRONCOMMAND"
echo $FULLCOMMAND > $CRONTABFILE
sed -ie s!"%"!!g $CRONTABFILE
cat $CRONTABFILE
if [ -f /bin/enigma ]; then
if [ -f /var/etc/crontab ]; then
cat /var/etc/crontab > $CRONTABFILE
else
rm $CRONTABFILE
touch $CRONTABFILE
fi
else
$CRONTAB -l > $CRONTABFILE 
fi
echo $FULLCOMMAND >> $CRONTABFILE
sed -ie s!"%"!!g $CRONTABFILE
#echo "--------------------------------------------------"
#echo "appendign line to crontab now ..."
if [ -f /bin/enigma ]; then
cp $CRONTABFILE /var/etc/crontab
else
$CRONTAB $CRONTABFILE
fi
echo "--------------------------------------------------"
echo "Displaying new crontab:"
echo "--------------------------------------------------"
if [ -f /bin/enigma ]; then
if [ -f /var/etc/crontab ]; then
cat /var/etc/crontab
fi
else
$CRONTAB -l
fi
echo "--------------------------------------------------"
exit 0
;;
    *)
        echo "-----------------------------------------------------"
	echo "Usage: $0 {list|add|delete|info|time|stop|start|restart|reload|"
	echo "                       enable|disable|reboot|halt|kill|man}"
        echo "-----------------------------------------------------"
        echo "list       option lists the crontab"
        echo "add        option adds command to the crontab with time"
        echo "delay      option adds command to the crontab with delay"
        echo "delete     option deletes the crontab"
        echo "info       option displays info f cron dameon is running"
        echo "time       option displays internal time used by cron dameon"
        echo "stop       option stops the cron dameon"
        echo "start      option starts the cron dameon"
        echo "restart    option restarts the cron dameon"
        echo "reload     option reloads the crontab"
        echo "enable     option enables cronmanager and cron daemon"
        echo "disable    option disables cronmanager and cron daemon"
        echo "reboot     option reboots Dreambox"
        echo "halt       option halts Dreambox - for example for flashing"
        echo "kill       option will restart only enigma2"
        echo "man        option displays longer help text"
        echo "-----------------------------------------------------"
	exit 1
	;;
esac
